import 'package:flutter/foundation.dart';
import 'package:flutter/widgets.dart';

class DjinnService<TState> {
  TState _state;
  TState get state => _state;

  List<Function> _listeners = [];
  List<State> _widgets = [];

  void init() {}

  void updateState() {
    _callListeners();
  }

  void listen<T extends State>(T widget) {
    _widgets.add(widget);
  }

  void dispose<T extends State>(T widget) {
    _widgets.remove(widget);
  }

  Function subscribe(Function fn) {
    _listeners.add(fn);
    return () => _removeListener(fn);
  }

  _removeListener(Function fn) {
    _listeners.remove(fn);
  }

  void _callListeners() {
    _listeners.forEach((Function it) => it());
    // ignore: INVALID_USE_OF_PROTECTED_MEMBER
    _widgets.forEach((State it) => it.setState(() {}));
  }
}

typedef void SetStateFn(VoidCallback fn);

class StateUpdate {
  dynamic current;
  dynamic previous;

  StateUpdate(this.current, this.previous);
}
