import 'package:flutter_test/flutter_test.dart';

import 'package:djinn_flutter/djinn_flutter.dart';


class CounterState {
  int count;

  CounterState({this.count});
}

class Counter extends DjinnService<CounterState> {
  var state = CounterState(count: 0);

  increment() {
    state.count++;
    updateState();
  }

  decrement() {
    state.count--;
    updateState();
  }
}

void main() {
  test('register a service', () {
    Djinn().register(() => Counter());
    Djinn().init();

    final Counter service = Djinn().get();

    expect(service != null, true);
    expect(service.state.count, 0);

    Djinn().remove<Counter>();
  });

  test('propagate changes', () {
    Djinn().register(() => Counter());
    Djinn().init();

    final Counter service = Djinn().get();
    service.increment();

    expect(service.state.count, 1);

    Djinn().remove<Counter>();
  });
}
